#include <stdio.h>
#include <math.h>

int main()
{
	
	int n,i,j;
	scanf("%d",&n);
	int c;
	scanf("%d",&c);
	int q;
	scanf("%d",&q);
	char str[n];
    scanf("%s", str);
    int a[q];
    int b[q];
    for(i=0;i<q;i++)
    {
    	scanf("%d",&a[i]);
    	scanf("%d",&b[i]);
	}
	int e;
    for(i=0;i<q;i++)
    {
    	for(j=0;j<n;j++)
    	{
    		if(str[j]>=a[i] && str[j]<=b[i])
    		{
    			if(str[j]=='1')
    				str[j]='0';
    			if(str[j]=='0')
    				str[j]='1';
			}
			
		}
		
		int br=0;
		    
		for(j=0;j<n;j++)
		{
			if(str[j]=='1')
				br++;
		}
    	
    	if(n-br<br)
    	{
    		if(br>=c)
    		{
    			e=c+(n-br);
			}
			else
			{
				e=br;
			}
		}
		else
		{
			if(br>=c)
    		{
    			e=c+(n-br);
			}
			else
			{
				e=br;
			}
		}
		
		
		printf("%d\n",e);
	}
    
    return 0;
}